# encoding: utf-8

module VisiQuery
  class BanReason 
    attr_accessor :reason, :comment
    attr_accessor :updated_at, :created_at, :expires_at

    def self.from_json body
      BanReason.new(body['user_name'], body['profile_id']).tap do |ban|
        ban.reason = body['reason']
        ban.comment = body['comment']

        ban.created_at = DateTime.parse body['created_at']
        ban.updated_at = DateTime.parse body['updated_at']

        if body['expires_at']
          ban.expires_at = DateTime.parse body['expires_at']
        end
      end
    end

    def initialize name, id
      @id = id
      @name = name
    end

    def to_hash
      Hash.new.tap do |result|
        result['profile_id'] = @id
        result['user_name'] = @name if @name
        
        result['reason'] = reason if reason
        result['comment'] = comment if comment
        result['expires_at'] = expires_at if expires_at
      end
    end
  end
end
